Ich habe nginx mit benutzerdefinierten Pfaden für meinen Produktionsserver kompiliert und beim Versuch, den Dienst zu starten / neu zu starten, mit:
service nginx start
oder
service nginx restart
Es wird eine neue Zeile eingegeben, ohne die Shell zurückzugeben:
Das Problem ist also, dass ich nginx nicht mit dem service
Befehl steuern kann . Der Dienst wird tatsächlich ausgeführt, gibt mir jedoch keine Shell zurück, sodass ich immer ctrl+ drücken muss c, um ihn zurückzubekommen.
Ich muss auch erwähnen, dass nginx einwandfrei funktioniert, wenn es über einen eigenen nginx
Befehl aufgerufen wird, und einfach gestoppt oder neu geladen werden kann nginx -s stop/reload
.
Dieses Problem besteht systemctl start nginx
auch weiterhin, systemctl stop nginx
funktioniert aber einwandfrei.
Die Info:
$ lsb_release -a
Distributor ID: Ubuntu
Description: Ubuntu 15.10
Release: 15.10
Codename: wily
$ uname -r
4.2.0-27-generic
$ nginx -V
nginx version: nginx/1.9.11
built by gcc 5.2.1 20151010 (Ubuntu 5.2.1-22ubuntu2)
built with OpenSSL 1.0.2d 9 Jul 2015
TLS SNI support enabled
configure arguments: --sbin-path=/usr/bin/nginx --conf-path=/etc/nginx/nginx.conf --error-log-path=/var/log/nginx/error.log --http-log-path=/var/log/nginx/access.log --with-debug --with-pcre --with-http_ssl_module
$ cat /etc/default/nginx
NGINX_CONF_FILE=/etc/nginx/nginx.conf
DAEMON=/usr/bin/nginx
$ cat /etc/init.d/nginx
NGINX_BIN=/usr/bin/nginx
test -x $NGINX_BIN || { echo "$NGINX_BIN not installed";
if [ "$1" = "stop" ]; then exit 0;
else exit 5; fi; }
NGINX_PID=/var/run/nginx.pid
# Check for existence of needed config file and read it
#NGINX_CONFIG=/etc/sysconfig/nginx
#test -r $NGINX_CONFIG || { echo "$NGINX_CONFIG not existing";
# if [ "$1" = "stop" ]; then exit 0;
# else exit 6; fi; }
#
# Read config
#. $NGINX_CONFIG
# Source LSB init functions
# providing start_daemon, killproc, pidofproc,
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions
# Shell functions sourced from /etc/rc.status:
# rc_check check and set local and overall rc status
# rc_status check and set local and overall rc status
# rc_status -v be verbose in local rc status and clear it afterwards
# rc_status -v -r ditto and clear both the local and overall rc status
# rc_status -s display "skipped" and exit with status 3
# rc_status -u display "unused" and exit with status 3
# rc_failed set local and overall rc status to failed
# rc_failed <num> set local and overall rc status to <num>
# rc_reset clear both the local and overall rc status
# rc_exit exit appropriate to overall rc status
# rc_active checks whether a service is activated by symlinks
. /etc/rc.status
# Reset status of this service
rc_reset
# Return values acc. to LSB for all commands but status:
# 0 - success
# 1 - generic or unspecified error
# 2 - invalid or excess argument(s)
# 3 - unimplemented feature (e.g. "reload")
# 4 - user had insufficient privileges
# 5 - program is not installed
# 6 - program is not configured
# 7 - program is not running
# 8--199 - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
#
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.
case "$1" in
start)
echo -n "Starting nginx "
## Start daemon with startproc(8). If this fails
## the return value is set appropriately by startproc.
/sbin/startproc -p $NGINX_PID $NGINX_BIN
# Remember status and be verbose
rc_status -v
;;
stop)
echo -n "Shutting down nginx "
## Stop daemon with killproc(8) and if this fails
## killproc sets the return value according to LSB.
/sbin/killproc -p $NGINX_PID -TERM $NGINX_BIN
# Remember status and be verbose
rc_status -v
;;
try-restart|condrestart)
## Do a restart only if the service was active before.
## Note: try-restart is now part of LSB (as of 1.9).
## RH has a similar command named condrestart.
if test "$1" = "condrestart"; then
echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
fi
$0 status
if test $? = 0; then
$0 restart
else
rc_reset # Not running is not a failure.
fi
# Remember status and be quiet
rc_status
;;
restart)
## Stop the service and regardless of whether it was
## running or not, start it again.
$0 stop
$0 start
# Remember status and be quiet
rc_status
;;
force-reload)
## Signal the daemon to reload its config. Most daemons
## do this on signal 1 (SIGHUP).
## If it does not support it, restart the service if it
## is running.
echo -n "Reload service nginx "
## if it supports it:
/sbin/killproc -p $NGINX_PID -HUP $NGINX_BIN
#touch /run/nginx.pid
rc_status -v
## Otherwise:
#$0 try-restart
#rc_status
;;
reload)
## Like force-reload, but if daemon does not support
## signaling, do nothing (!)
# If it supports signaling:
echo -n "Reload service nginx "
/sbin/killproc -p $NGINX_PID -HUP $NGINX_BIN
#touch /run/nginx.pid
rc_status -v
## Otherwise if it does not support reload:
#rc_failed 3
#rc_status -v
;;
reopen)
echo -n "Reopen the logfiles "
/sbin/killproc -p $NGINX_PID -USR1 $NGINX_BIN
rc_status -v
;;
status)
echo -n "Checking for service nginx "
## Check status with checkproc(8), if process is running
## checkproc will return with exit status 0.
# Return value is slightly different for the status command:
# 0 - service up and running
# 1 - service dead, but /run/ pid file exists
# 2 - service dead, but /var/lock/ lock file exists
# 3 - service not running (unused)
# 4 - service status unknown :-(
# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
# NOTE: checkproc returns LSB compliant status values.
/sbin/checkproc -p $NGINX_PID $NGINX_BIN
# NOTE: rc_status knows that we called this init script with
# "status" option and adapts its messages accordingly.
rc_status -v
;;
probe)
## Optional: Probe for the necessity of a reload, print out the
## argument to this init script which is required for a reload.
## Note: probe is not (yet) part of LSB (as of 1.9)
test /etc/nginx/nginx.conf -nt /run/nginx.pid && echo reload
;;
*)
echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
exit 1
;;
esac
rc_exit
UPDATE : Das Problem besteht auch weiterhin, wenn der Docker-Container unter CoreOS Alpha verwendet wird.
UPDATE 2 : Hier sind die Ausgaben für strace -o log -f service nginx start
und journalctl -xe
:
strace -o log -f service nginx start
Protokollausgabe [zu lang, um hier zu posten]
journalctl -xe
Feb 26 07:25:38 lucifer polkitd(authority=local)[870]: Registered Authentication Agent for unix-process:8181:8813595 (system bus name :1.77 [/usr/bin/pkttyagent --notify-fd 5 --fallback], o
Feb 26 07:25:38 lucifer systemd[1]: Starting The NGINX HTTP and reverse proxy server...
-- Subject: Unit nginx.service has begun start-up
-- Defined-By: systemd
-- Support: http://lists.freedesktop.org/mailman/listinfo/systemd-devel
--
-- Unit nginx.service has begun starting up.
Feb 26 07:25:38 lucifer nginx[8211]: nginx: the configuration file /etc/nginx/nginx.conf syntax is ok
Feb 26 07:25:38 lucifer nginx[8211]: nginx: configuration file /etc/nginx/nginx.conf test is successful
Feb 26 07:25:38 lucifer systemd[1]: nginx.service: PID file /var/run/nginx.pid not readable (yet?) after start: No such file or directory
Feb 26 07:25:43 lucifer polkitd(authority=local)[870]: Unregistered Authentication Agent for unix-process:8181:8813595 (system bus name :1.77, object path /org/freedesktop/PolicyKit1/Authen
nginx
es gut funktioniert, wenn Sie von einem Cli aus starten, müssen Sie das Service- Skript debuggen .journalctl
undstrace
hier gepostet , aber ehrlich gesagt habe ich keine Ahnung, wie ich das Problem anhand der Ausgabe von strace verstehen soll. Ich würde mich über ein bisschen Hilfe freuen, wenn möglich.Antworten:
Ich habe das gleiche Problem mit Ubuntu 16.04, systemd und NginX 1.10.1 aus dem Quellcode.
Ich habe die Standarddatei nginx.service verwendet: https://www.nginx.com/resources/wiki/start/topics/examples/systemd/
Das Problem war die nginx.pid-Beschichtung, um es zu beheben I:
Nginx ohne den Service angezündet
Die Lokalisierungsdatenbank wurde aktualisiert:
Den Speicherort der PID-Datei gefunden
Und die Datei nginx.service an den Speicherort aktualisiert, an dem ich sie gefunden habe
(Keine Ahnung, warum es in meinem Protokollverzeichnis gespeichert ist ...)
Führen Sie dann daemon-reload aus, um die Datei nginx.service neu zu laden
Danach funktioniert "systemctl start nginx" wie ein Zauber. Hoffe das hilft.
quelle
/usr/local/nginx/logs/nginx.pid
als Weg fürPIDFile
mich gearbeitet (mit Ubuntu - Server 16.04.2 und nginx 1.12.1). ThxEs hängt wegen dieses Fehlers:
Neuere Linux-Distributionen werden mitgeliefert systemd . Wenn Sie einen mit Ihrer Distribution gebündelten Dienst verwenden, wird dieser bereits für systemd konfiguriert.
Da Sie Nginx aus den Quellen kompilieren und eine SysV-Init-Datei ( /etc/init.d/nginx ) verwenden, verwendet systemd einen Generator, um es zu analysieren ( systemd-sysv-generator ).
In Ihrem SysV-Skript definieren Sie die PID-Datei und starten den Prozess mit:
Wenn ich mich nicht irre, verwenden Sie ein SUSE Linux-Init-Skript unter Ubuntu (aufgrund des Befehls startproc ). Dieser Befehl startproc liest nur die PID-Datei (angegeben durch den Parameter -p ) und erstellt sie nicht, also systemd kann keine PID-Datei finden und sie hängt.
In Ihrem Fall besteht die Lösung darin, entweder die PID-Datei in Ihrem SysV-Init-Skript (am Speicherort /var/run/nginx.pid ) zu erstellen , ein Ubuntu-SysV-Init-Skript oder ein Systemd-Skript zu verwenden.
Dies kann auch passieren (nicht was mit Ihnen passiert), wenn Sie ein korrektes SysV-Init-Skript haben, das eine PID-Datei erstellt, aber es unterscheidet sich von dem oben in der Datei kommentierten. Der systemd-Generator liest die Kommentare, zum Beispiel diesen:
Und verwendet die dort definierte PID-Datei.
Mehr Informationen:
quelle
Es klingt wie
/usr/lib/systemd/system/nginx.service
missgebildet. Stellen Sie sicher, dass diese Zeile gesetzt ist:Alternativ können Sie den
[Service]
Abschnitt in eine neue Datei mit dem Namen kopieren/etc/systemd/system/nginx.service
. Mit eingefügten Einheitendateien können/etc/systemd/system
Sie Abschnitte überschreiben, ohne die gesamte vom Paketmanager installierte Datei zu duplizieren.quelle